"use strict";
this.name               = "combat_MFD";
this.author               = "Norby, Zireael";
this.copyright            = "2014 Norby, Zireael";
this.description         = "Makes MFDs more useful by displaying some info";
this.version            = "1.5";
this.licence     = "CC BY-NC-SA 4.0";

this.$ExactNumbers = false; //energy and shield values for debug

this.$combat_MFD = null; //store the final displayed string with player and target data
this.$DmgEqs = []; //store damaged eq keys
this.$InfoTimer = null; //store pointer to timer
this.$InfoTimer2 = null; //store pointer to timer2

this.startUp = function() {
	if(player.ship && player.ship.isValid)
		this.$PlayerPrevPos = player.ship.position;
	else this.$PlayerPrevPos = [0,0,0];
	this.$Target = null;
	this.$TargetPrevPos = [0,0,0];
	this.$Hws = worldScripts.hardships;
	this.$Iws = worldScripts["IronHide Armour Script"];
	this.$Ows = worldScripts.towbar;
	this.$Rws = worldScripts.torustosun;
	this.$Sws = worldScripts.shieldequalizercapacitors;
	this.$Tws = worldScripts.telescope;
	this.$InfoTimer = null; //store pointer to timer
	this.$InfoTimer2 = null; //store pointer to timer2

	this.$DmgEqs = []; //store damaged eq keys
	var eq = player.ship.equipment;
	var i=-1;
	while(eq[++i]) { //skip noname eqs awarded by NumericHUD
		if( eq[i].name.length > 0
			&& player.ship.equipmentStatus(eq[i].equipmentKey)=="EQUIPMENT_DAMAGED")
			this.$DmgEqs.push(eq[i].equipmentKey);
	}
}
	
this.equipmentDamaged = function(equipment) {
	this.$DmgEqs.push(equipment);
//	log("combat_MFD", "DmgEqs: "+this.$DmgEqs); //debug
}

this.shipAttackedWithMissile = function(missile, whom) {
	if( whom && whom.script ) {
		if( whom.script.$combat_MFD_missiles > 0 )
			whom.script.$combat_MFD_missiles++;
		else whom.script.$combat_MFD_missiles = 1;
		if(missile.dataKey == "ecm-proof-missile")
			 whom.script.$combat_MFD_hardmissile = true;
	}
}

this.shipBeingAttacked = this.shipBeingAttackedUnsuccessfully = function(whom) {
     if(whom && whom.script) whom.script.$combat_MFD_attacked = true; //flag for display Laser type
}

this.shipWillLaunchFromStation = function() {
	//the timer interval is bound to the multipliers in speed calculations so must change together
	if( !this.$InfoTimer ) {
		this.$InfoTimer = new Timer(this, this.$showCombatInfo.bind(this), 0, 0.5);
		if(this.$Sws) { //turn of irritating messages and sounds which is unneccesary with this MFD
			this.$Sws.togglemessages = "OFF";
			this.$Sws.togglesoundfx2 = "OFF";
		}
	}
		//log("CombatMFD",player.ship.equipmentStatus("EQ_COMBATMFD")+" "+this.$InfoTimer);//debug
	this.$InfoTimer2Done = false;

	if( this.$ExactNumbers ) {//debug
		var s = system.addShips("pirate", 1,
			system.mainStation.position.add(player.ship.heading.multiply(3000)), 100);//debug target
		if( s && s[0]) {
			//s[0].forwardWeapon = null;//setAI("nullAI.plist");
			s[0].bounty = 1;
			s[0].target = player.ship;
			//s[0].displayName = s[0].name + " Target";
		}
	}
}

this.$showCombatInfo = function() {
	var p = player.ship;
//	log("combat_MFD", "EQ_COMBATMFD: "+p.equipmentStatus("EQ_COMBATMFD")); //debug
	if(p && p.isValid && p.equipmentStatus("EQ_COMBATMFD") == "EQUIPMENT_OK") {
		var pp = p.position;
		var target = ""; //gather data of player's current target
		var t = p.target;
		if(t && t.isValid) {
			var tdn = t.displayName;//must read name before handle telescopemarker
			var st = "";
			if(t.isWormhole) {
				tdn = "Wormhole";
				if(p.equipmentStatus("EQ_WORMHOLE_SCANNER") == "EQUIPMENT_OK") {
					if( this.$InfoTimer2Done && this.$LastWormhole == t ) {
						//log("CombatMFD",t.expiryTime+" "+clock.seconds+" "+t.arrivalTime);//debug
						if(t.destination) tdn += " to "+System.systemNameForID(t.destination);
						if(t.expiryTime) tdn = this.$AlignedText(tdn, "expire in "+
							Math.round( t.expiryTime - clock.seconds )+" s");
						if(t.arrivalTime) st = "\nTravel Time: "+(Math.round(
							(t.arrivalTime - clock.seconds)/360)/10)+" h";
					} else { //5s delay before show Wormhole info
						tdn += " scanning...";
						if(this.$LastWormhole != t) {
							this.$LastWormhole = t;
							this.$InfoTimer2Done = false;
							if(this.$InfoTimer2) {
								this.$InfoTimer2.stop();
								delete this.$InfoTimer2;
							}
							this.$InfoTimer2 = new Timer(this, this.$showWormholeInfo.bind(this), 6);
						}
					}
				}
			}

			//telescope far target over scanner range
			var tsp = "";
			var t2 = null;
			if(this.$Tws && t.dataKey=="telescopemarker") {//change the pointer to the real target
				t2 = this.$Tws.$TelescopeList[this.$Tws.$TelescopeListi-1];
				//this.$Tws.$TelescopeTarget is not good: not refreshed when
				//the target is changed automatically in weapons offline mode
				if(t2 && t2.isValid) t = t2;
				var k = tdn.indexOf("km "); //chop the x km from the begin of marker name
				if( k > -1 && k < 10 ) tdn = tdn.substr( k+3 );
			}
			
			 //target speed
			if(t.maxSpeed > 0) {
				if(this.$Target == t) { //need 2 pos. for speed, use velocity for Q-Charger
					tsp = Math.round(t.velocity.magnitude()/10)*10; //stable but can not show FTL drive
					if(tsp > 31 * t.maxSpeed ) { //support for FarPlanets
						var psp = Math.round(0.2*t.position.distanceTo(this.$TargetPrevPos))*10;
						if( psp > 1.1* tsp ) tsp = psp;//instable but need to follow position changes
					}
				} else {
					this.$Target = t; //first time save position
					tsp = Math.round(t.velocity.magnitude()/10)*10;
				}
				if( tsp > 10000000 ) tsp = Math.round( tsp / 1000000 ) + " Mm/s";
				else if( tsp > 1000000 ) tsp = Math.round( tsp / 1000 ) + " km/s";
				else tsp = Math.round( tsp ) + " m/s";
				//tsp = "Speed: " + tsp;
			}
			this.$TargetPrevPos = t.position;
			
			//target distance
			var ra = Math.round(t.collisionRadius);
			var di = Math.round(t.position.distanceTo(pp)-ra);
			if(di > 1000000000) di = Math.floor(di/1000000000)+" Mkm";
			else if(di > 25600) di = Math.floor(di/1000)+" km";
			else di += " m";
			if( ra > 100000 ) ra = Math.round( ra / 1000 ) + " km";
			else ra += " m";
			
			//target radius
			var sr = "";
			if( !t.isShip || t.isPlanet || t.isSun || t.isRock ) sr = "Radius: "+ra;
			else {	//facing shield
				if(!t2) { //within scanner range only
					sr = "Shield Radius: ";
					if(this.$AftShieldFacing(t)) sr = sr + ra + "    Aft";
					else sr = sr + ra + "   Front";
				}
				
				var d = false;
				if(t.isDerelict) d = "Derelict";
				else {
					if(!t2 && t.energy && t.maxEnergy ) {
						if(t.energy < 0.2*t.maxEnergy ) d = "Weak!";
						else if(t.energy < 0.4*t.maxEnergy ) d = "Damaged!";
					}
				}
				if( d ) sr = this.$AlignedText(sr, d);
			}
			
			//target laser
			var laser = "";
			if( t.forwardWeapon ) laser = "Laser: Unknown";
			if( t.script && t.script.$combat_MFD_attacked && t.currentWeapon )
				laser = this.$AlignedText("Laser: "+t.currentWeapon.name,
							  "Range: "+Math.round(t.weaponRange/100)/10+" km");
			
			 //target status
			if(!t2 && p.equipmentStatus("EQ_SCANNER_SHOW_MISSILE_TARGET") == "EQUIPMENT_OK"
				&& (!t.isWormhole&&t.isShip&&t.isPiloted||t.isDerelict)) {
				st = "Status:";
				if(t.isDerelict) {
					if(this.$Ows && t.script) { //Towbar status
						if(t.script.$TowbarUsableShip) st += " Usable!";
						else if(t.script.$TowbarMinedShip) st += " Mined";
						if(t.script.$TowbarEmptyShip) st += " Empty";
						else st += " Trap or Treasure";
					}
				} else if(t.bounty>50) st += " Fugitive"; //legal status
				else if(t.bounty>0) st += " Offender";
				else st += " Clean";
				
				if( this.$ExactNumbers ) st += " "+Math.round(t.energy);//for debug
				
				//Missiles fired
				if( t.script) {
					var m = t.script.$combat_MFD_missiles;
					if( m > 0 ) {
						var s = "";
						if( m > 1 ) s = "s";
						if(t.script.$combat_MFD_hardmissile) m+=" Hard";
						st = this.$AlignedText(st, " Missile"+s+" fired: "+m);
					}
				}
			}
			
			//concatenate target info
			target = tdn + "\n" + this.$AlignedText("Distance: "+di, tsp) +
				"\n" + sr + "\n" + laser + "\n" + st;
		} else this.$Target = null;

		//player energy
		var ep = "Energy: "+10*Math.round(10*p.energy/p.maxEnergy)+"%";

		var eb = Math.floor(p.maxEnergy/64);//how many energy banks shown in hud
		var e = Math.ceil(p.energy/(p.maxEnergy/eb));
		var en = "";
		if( e < 2 ) en ="LAST BANK!"; //not exactly below 64, for example in Fer-De-Lance below 75
		else { //"SEE" indicator: letters mean shields, armour and energy for each double banks
			if(this.$Sws &&
				(p.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") != "EQUIPMENT_UNAVAILABLE" ||
				p.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") != "EQUIPMENT_UNAVAILABLE")) {
				var max = 64;
				if(this.$Sws.secforwardshieldcapacitormax)
					max = Math.max(max, this.$Sws.secforwardshieldcapacitormax);
				if(this.$Sws.secaftshieldcapacitormax)
					max = Math.max(max, this.$Sws.secaftshieldcapacitormax);
				en += this.$SEELetters( "C", max,
					this.$Sws.secforwardshieldcapacitor,
					this.$Sws.secaftshieldcapacitor,
					"EQ_FORWARD_SHIELD_CAPACITOR",
					"EQ_AFT_SHIELD_CAPACITOR",
					"EQ_BIGSHCAP", "EQ_BIGSHCAP2", "EQ_BIGSHCAP3");
			}
			if(p.equipmentStatus("EQ_NAVAL_SHIELD_BOOSTER") != "EQUIPMENT_UNAVAILABLE" )
				en += this.$SEELetters( "M", 128,
					Math.max(0, p.forwardShield-256),
					Math.max(0, p.aftShield-256),
					"EQ_NAVAL_SHIELD_BOOSTER");
			if(p.equipmentStatus("EQ_SHIELD_BOOSTER") != "EQUIPMENT_UNAVAILABLE" )
				en += this.$SEELetters( "B", 128,
					Math.min(128, Math.max(0, p.forwardShield-128)),
					Math.min(128, Math.max(0, p.aftShield-128)),
					"EQ_SHIELD_BOOSTER");
			en += this.$SEELetters( "S", 128,
				Math.min(128, p.forwardShield),
				Math.min(128, p.aftShield),
				"EQ_BREAKABLE_SHIELD_FORE_SMALL",
				"EQ_BREAKABLE_SHIELD_AFT_SMALL",
				"EQ_BREAKABLE_SHIELD_FORE_MEDIUM",
				"EQ_BREAKABLE_SHIELD_AFT_MEDIUM",
				"EQ_BREAKABLE_SHIELD_FORE_LARGE",
				"EQ_BREAKABLE_SHIELD_AFT_LARGE");
			if(this.$Hws) en += this.$SEELetters( "A", //armours in HardShip OXP
				Math.max(this.$Hws.$HardShips_AMax[0][0], //fw
					this.$Hws.$HardShips_AMax[0][1]), //aft
				this.$Hws.$HardShips_Armour[0][0], //fw armour value
				this.$Hws.$HardShips_Armour[0][1]);//aft
			if( this.$Iws ) { //IronHide armour
				var ihs = missionVariables.ironHide_strength;
				var ihp = missionVariables.ironHide_percentage;
				var ihv = 0;
				if(ihs > 0 && ihp > 0) ihv = ihs * ( ihp / 100 );
				if(ihv > 0) en += this.$SEELetters( "H", ihs, ihv, ihv);
//				log("combat_MFD", "H: "+ihs+" "+ihp+" "+ihv); //debug
			}
			en += this.$SEELetters( "E", p.maxEnergy, p.energy, p.energy,
				"EQ_BREAKABLE_ENERGY_UNIT_SMALL",
				"EQ_BREAKABLE_ENERGY_UNIT_MEDIUM",
				"EQ_BREAKABLE_ENERGY_UNIT_LARGE");
			//"SEE" indicator is done at this point in en variable
			
			//count enery+armour+shield banks
			e = p.energy + Math.min(p.forwardShield, p.aftShield);
			if(this.$Sws) e += Math.min(this.$Sws.secforwardshieldcapacitor,
				this.$Sws.secaftshieldcapacitor);
			if(this.$Hws) e += Math.min(this.$Hws.$HardShips_Armour[0][0], //fw
				Math.min(this.$Hws.$HardShips_Armour[0][1],//aft
				Math.min(this.$Hws.$HardShips_Armour[0][2],//port
				Math.min(this.$Hws.$HardShips_Armour[0][3],//sb
				Math.min(this.$Hws.$HardShips_Armour[0][4],//top
					this.$Hws.$HardShips_Armour[0][5])))));//bottom
			if( this.$Iws ) e += ihv; //ironhide value, calculated above
			en += " (" + Math.round( e / 64 ) + ")";
		}
		
		//player shields
		var fs = Math.round(p.forwardShield); 
		if(this.$Sws) fs += Math.round(this.$Sws.secforwardshieldcapacitor);
		var as = Math.round(p.aftShield);
		if(this.$Sws) as += Math.round(this.$Sws.secaftshieldcapacitor);
		var sh = "Shields: "+this.$ForwardPercent(fs) + "%/" + this.$AftPercent(as) + "%";
		
		if( this.$ExactNumbers ) { //for debug
			en += ": "+Math.round(p.energy);
			sh += " ("+fs+"/"+as+")";
		}

		//"One-shot" indicator for Energy Bomb and one-shot equipments in HardShips OXP
		var one = "";
		if( p.equipmentStatus("EQ_ENERGY_BOMB") == "EQUIPMENT_OK") one += "B";
		if(this.$Hws) {
			if(p.equipmentStatus("EQ_ADDITIONAL_CORE_HULL") == "EQUIPMENT_OK") one += "C";
			if( p.equipmentStatus("EQ_EEG") == "EQUIPMENT_OK") one += "E";
		}
		if( p.equipmentStatus("EQ_GAL_DRIVE") == "EQUIPMENT_OK") one += "G";
		if( this.$Hws && p.equipmentStatus("EQ_HTCAT") == "EQUIPMENT_OK") one += "H";
		if( p.equipmentStatus("EQ_ESCAPE_POD") == "EQUIPMENT_OK") one += "P";
		if( this.$Hws && p.equipmentStatus("EQ_REG") == "EQUIPMENT_OK") one += "R";
		if( p.equipmentStatus("EQ_EEU") == "EQUIPMENT_OK") one += "U";
		sh = this.$AlignedText(sh, one);
		
		//player legal status
		var ps = "";
		if(p.bounty>50) {
			ps += "Fugitive ("+p.bounty+")";
			if(p.bounty<100) ps += "  ";
		} else if(p.bounty>0) {
			ps += "Offender ("+p.bounty+") ";
			if(p.bounty<10) ps += "  ";
		} else ps += "Status: Clean ";

		//player fuel
		ps += " Fuel: "+(p.fuel).toFixed(1)+"ly";
		
		//torus multiplyer and player speed
		var tm = "";
		var sp = Math.round(p.velocity.magnitude()/10)*10; //stable but can not show FTL drive nor Torus multiplier
		if( this.$Rws && this.$Rws.$TorusToSunBonus > 1 ) {
			tm = " "+Math.round(this.$Rws.$TorusToSunBonus)+"x";
			sp = Math.round(this.$Rws.$TorusToSunBonus * 3.2 * p.maxSpeed)*10;
		} else {
			if(sp > 31 * p.maxSpeed ) { //support for FarPlanets and any other position changer drives
				var psp = Math.round(0.2*pp.distanceTo(this.$PlayerPrevPos))*10;
				if( psp > 1.1*sp ) sp = psp;//instable but need to follow position changes
			}
		}
		if( sp > 10000000 ) sp = Math.round( sp / 1000000 ) + " Mm/s";
		else if( sp > 1000000 ) sp = Math.round( sp / 1000 ) + " km/s";
		else if(tm.length > 0) sp += "m/s"; else sp += " m/s";
		this.$PlayerPrevPos = pp;
		

		//damaged equipment if any
		var dm = ""; 
		var dmg = "";
		var dmgeqs = [];
//		log("combat_MFD", "DmgEqs: "+this.$DmgEqs); //debug
		for( var i=0; i<this.$DmgEqs.length; i++ ) //remove fixed ones from the damaged list
			if(p.equipmentStatus(this.$DmgEqs[i])=="EQUIPMENT_DAMAGED")
				dmgeqs.push(this.$DmgEqs[i]);
		this.$DmgEqs = dmgeqs;
//		log("combat_MFD", "DmgEqs: "+this.$DmgEqs); //debug
		if( dmgeqs && dmgeqs.length > 0 ) {  //show the name of the lastly damaged equipment
			dmg = EquipmentInfo.infoForKey(dmgeqs[dmgeqs.length-1]).name;
			if( dmgeqs.length > 1 ) dm = "(+"+(dmgeqs.length-1)+")";//+how many other eq damaged
		}
		if(dmg.length > 0) dmg = this.$AlignedText("Damaged: "+dmg, dm);

		//show the result
		this.$combat_MFD = this.$AlignedText(ep, en)+"\n"+sh+"\n"+
			this.$AlignedText(ps, sp+tm)+"\n"+dmg+"\n\n"+target;
		p.setMultiFunctionText("combat_MFD", this.$combat_MFD, false);
	}
}

this.$ForwardPercent = function(current) {
  var max = 128;//player.ship.maxForwardShield;
  var result = 10*Math.round(10*current / max);
  return result;
}

this.$AftPercent = function(current) {
  var max = 128;//player.ship.maxAftShield;
  var result = 10*Math.round(10*current / max);
  return result;
}

this.$showWormholeInfo = function() { //6s delay before show Wormhole info
	this.$InfoTimer2Done = true;
	if(this.$InfoTimer2) {
		this.$InfoTimer2.stop();
		delete this.$InfoTimer2;
	}
}

this.$AlignedText = function(left, right) { //insert as many spaces between as fill the line
	var width = 14.2;
	var space = " ";
	left += space;
	var t = left + right;
	while( defaultFont.measureString(t) < width ) {
		left += space;
		t = left + right;
	}
	//fine tune with hair spaces - from spara's marketObserver
	var hairSpace = String.fromCharCode(31);
	while ( defaultFont.measureString(t + hairSpace) < width ) {
		left += hairSpace;
		t = left + right;
	}
	return(t);
}

this.$SEELetters = function(letter, max, fw, aft, eq1, eq2, eq3, eq4, eq5, eq6) {
	var s = 0; //smaller shield side
	var l = 0; //larger shield side
	var p = player.ship;
	if(eq1 && p.equipmentStatus(eq1)=="EQUIPMENT_DAMAGED"
		|| eq2 && p.equipmentStatus(eq2)=="EQUIPMENT_DAMAGED"
		|| eq3 && p.equipmentStatus(eq3)=="EQUIPMENT_DAMAGED"
		|| eq4 && p.equipmentStatus(eq4)=="EQUIPMENT_DAMAGED"
		|| eq5 && p.equipmentStatus(eq5)=="EQUIPMENT_DAMAGED"
		|| eq6 && p.equipmentStatus(eq6)=="EQUIPMENT_DAMAGED")
		letter = "_"; //damaged
	s = Math.round(Math.min(fw, aft)/128);
	l = Math.round(Math.max(fw, aft)/128);
	var r = "";
	var t = Math.round(max/128); //total letters
	for(var i = 0; i < t; i++ )
		if( letter == "_" ) r += letter; //damaged equipment
		else if( i < t-l ) r += "-"; //empty bank
		else if( i < t-s ) r += letter.toLowerCase(); //one side of shield is up only
		else r += letter; //both forward and aft shield is up
//	log("combat_MFD", letter+": "+max+" "+fw+" "+aft+" "+i+". "+(t-s)+" "+(t-l)+" "+t+" "+r); //debug
	return(r);
}

this.$AftShieldFacing = function(ship) { //determine which shield of the target facing to player ship
	if(ship.vectorForward.angleTo(ship.position.subtract(player.ship.position)) <= Math.PI/2)
		return(true);
	return(false);
}

